/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;using UnityEngine.EventSystems;using System.Collections.Generic;namespace PluginIdea{    class MouseWheelToSlider : MVRScript    {        public GraphicRaycaster RaycastInCanvas;        private JSONStorableFloat speed;        private JSONStorableFloat shift_speed_mul;        private List<RaycastResult> castList = new List<RaycastResult>();        public override void Init()        {            Utils.OnInitUI(CreateUIElement);            Utils.SetupInfoText(this, "<b>MouseWheelToSlider 1.1:</b>\n\n" +               "Speed : the speed at which Speed:Slider slides. " +               "Shift Speed Multiper: hold down Left Shift to speed up the sliding of the Slider.", 300, true);            speed = Utils.SetupSliderFloat(this, "Speed", 2f, 0.1f, 5f, false);            shift_speed_mul = Utils.SetupSliderFloat(this, "Shift Speed Multiper", 3f, 1f, 10f, false);        }        private void Update()        {            var cur = EventSystem.current.currentSelectedGameObject;            if (cur != null)            {                RaycastInCanvas = cur.GetComponentInParent<GraphicRaycaster>();                if (RaycastInCanvas != null)                {                    castList.Clear();                    CheckGuiRaycastObjects(castList);                    if (castList.Count > 0)                    {                        for (int i = 0; i < castList.Count; i++)                        {                            Slider slider1 = castList[i].gameObject.GetComponent<Slider>();                            if (slider1 != null)                            {                                float scrollValue = Input.GetAxis("Mouse ScrollWheel");                                if (Input.GetKey(KeyCode.LeftShift))                                {                                    scrollValue *= shift_speed_mul.val;                                }                                slider1.value += scrollValue * speed.val * 0.05f;                            }                        }                    }                }            }        }        private void CheckGuiRaycastObjects(List<RaycastResult> list)        {            PointerEventData eventData = new PointerEventData(EventSystem.current);            eventData.pressPosition = Input.mousePosition;            eventData.position = Input.mousePosition;            RaycastInCanvas.Raycast(eventData, list);        }        private void OnDestroy()        {            Utils.OnDestroyUI();        }    }}